/* application source */
var canvas = document.getElementById("skeletonsCanvas");
var context = canvas.getContext("2d");

function getSkeletons(jsonObject){
  
  
  
  if (context == null) {
      return;
  }
  try{
    if(recorder.recording){
      recorder.saveStep(jsonObject);
    }
  }catch(err){
  
  }
  
  context.clearRect(0, 0, canvas.width, canvas.height);

  for (var i = 0; i < jsonObject.skeletons.length; i++) {
	var headZ = 0;
    var hipZ = 0;

    //draw head
    var head = jsonObject.skeletons[i].joints[6];
    
    //http://www.codeproject.com/KB/dotnet/KinectGettingStarted/7.png
  //------------------------
  //[0] handright
  //[1] elbowright
  //[2] shoulderright
  //[3] handleft
  //[4] elbowleft
  //[5] shoulderleft
  //[6] head
  //[7] spineneck
  //[8] spinecenter
  //[9] hipcenter
  //[10] kneeleft
  //[11] kneeright
  //[12] ankleleft
  //[13] ankleright
    
    var shouldercenter = jsonObject.skeletons[i].joints[7];
    var shoulderleft = jsonObject.skeletons[i].joints[5];
    var shoulderright = jsonObject.skeletons[i].joints[2];
    var elbowright = jsonObject.skeletons[i].joints[1];
    var elbowleft = jsonObject.skeletons[i].joints[4];
    var handright = jsonObject.skeletons[i].joints[0];
    var handleft = jsonObject.skeletons[i].joints[3];
    //var wristright = jsonObject.skeletons[i].joints[10];
    //var wristleft = jsonObject.skeletons[i].joints[6];
    var hipcenter = jsonObject.skeletons[i].joints[9];
    var kneeleft = jsonObject.skeletons[i].joints[10];
    var kneeright = jsonObject.skeletons[i].joints[11];    
    var ankleleft = jsonObject.skeletons[i].joints[12];    
    var ankleright = jsonObject.skeletons[i].joints[13];    
    
    context.fillStyle = "#F7AF45"; //#EB5136
    context.strokeStyle = '#F7AF45'; 
    context.lineWidth = 10;
	
    
    context.beginPath()
    context.arc(head.x, head.y, 20, 0, Math.PI * 2, true);
    context.closePath()
    context.fill();	
    context.stroke(); 
    
    context.beginPath()
   		context.moveTo(head.x, head.y);
		context.lineTo(shouldercenter.x, shouldercenter.y);
    context.closePath()
    context.stroke(); 

    
    context.beginPath()
   		context.moveTo(shouldercenter.x, shouldercenter.y);
		context.lineTo(elbowright.x, elbowright.y);	    
    context.closePath()
    context.stroke(); 

   context.beginPath()
   		context.moveTo(elbowright.x, elbowright.y);
		context.lineTo(handright.x, handright.y);	    
    context.closePath()
    context.stroke(); 

    
   context.beginPath()
    	context.moveTo(shouldercenter.x, shouldercenter.y);
    	context.lineTo(elbowleft.x, elbowleft.y);
    context.closePath()
    context.stroke(); 

    context.beginPath()
   		context.moveTo(elbowleft.x, elbowleft.y);
		context.lineTo(handleft.x, handleft.y);	    
    context.closePath()
    context.stroke(); 
    
    context.beginPath()
    	context.moveTo(shouldercenter.x, shouldercenter.y);
    	context.lineTo(hipcenter.x, hipcenter.y);
    context.closePath()
    context.stroke(); 

    context.beginPath()
    	context.moveTo(hipcenter.x, hipcenter.y);
    	context.lineTo(kneeleft.x, kneeleft.y);    
    context.closePath()
    context.stroke(); 

    context.beginPath()
    	context.moveTo(kneeleft.x, kneeleft.y);
    	context.lineTo(ankleleft.x, ankleleft.y);    
    context.closePath()
    context.stroke(); 
    
    
    context.beginPath()
    	context.moveTo(hipcenter.x, hipcenter.y);
    	context.lineTo(kneeright.x, kneeright.y);    
     context.closePath()
    context.stroke(); 

    context.beginPath()
    	context.moveTo(kneeright.x, kneeright.y);
    	context.lineTo(ankleright.x, ankleright.y);    
    context.closePath()
    context.stroke(); 

    
    
    

    /*
    context.beginPath()
    context.arc(shoulderLeft.x, shoulderLeft.y, 20, 0, Math.PI * 2, true);
    context.closePath()
    context.fill();	
    context.stroke(); 
    
    context.beginPath()
    context.arc(shoulderRight.x, shoulderRight.y, 20, 0, Math.PI * 2, true);    
    context.closePath()
    context.fill();	
    context.stroke(); 

	*/
    
    
    
    
    /*for (var j = 0; j < jsonObject.skeletons[i].joints.length; j++) 
    {
      var joint = jsonObject.skeletons[i].joints[j];

      context.fillStyle = "#EC8B38";
      context.beginPath();
      context.arc(joint.x, joint.y, 10, 0, Math.PI * 2, true);
      context.closePath();
      context.fill();	
      
     }*/
	}
}

              
function msgFromArduino(val){
  if(val=='RFID: D466B496')
  {
    //document.getElementById("user").value(hola);
  	//$('.data').html('Hola Rafa, ahora mostramos tus propiedades!)';
  }
  else
  {
  	//$('#user').html('Hola Pedro, ahora mostramos tus propiedades!');
  }
  
  // RFID: 8087E210
	console.debug('From Arduino: ' + val);
}

function next() {
	if(isNotHome()){
      	$('.fp-prev').click();
    }
}

function prior() {
	if(isNotHome()){
      	$('.fp-next').click();
    }
}

function isNotHome(){
	var elementName = $('#menu').find('li.active').first().attr('data-menuanchor');
    return elementName != 'Home';
}

function noUser(){
  console.debug('No User :(');  
//sendToArduino('0');
  
}

function newUser() {
  console.debug('New User :)');  
  //sendToArduino('1');
}

function changeHandNone() {
	console.debug('Hand None');  
}

function changeHandRight() {
  	console.debug('Hand Right');  
}

function changeHandLeft() {
	console.debug('Hand Left');  
}





ubiquo = function(){
    var controls ={
	click:"Ubi---click",
	loaded:"Ubi---loaded"
    };

    var cursorInterval;
    var cursorIntervalWidth=0;
    var cursorStart = function(){
	var LoadingExists = document.getElementById("ubiCursorLoading");

	if(LoadingExists===null){
	    var body  = document.getElementsByTagName("body").item(0);
	    var myDiv= document.createElement("div");
	    myDiv.id="ubiCursorLoading";
	    myDiv.style.position="fixed";
	    myDiv.style.bottom="0px";
	    myDiv.style.right="0px";
	    myDiv.style.width="0px";
	    myDiv.style.height="30px";
      myDiv.style.zIndex="99999";
	    myDiv.style.backgroundColor="black";

	    body.appendChild(myDiv);
	}
	cursorInterval = setInterval(function(){
	    cursorIntervalWidth+=1;
	    var LoadingExists = document.getElementById("ubiCursorLoading");
	    LoadingExists.style.width=cursorIntervalWidth+"%";
	    
	},20);
	
    };
    
    var cursorEnd = function(){
	var LoadingExists = document.getElementById("ubiCursorLoading");
	cursorIntervalWidth=0;
	clearTimeout(cursorInterval);
	LoadingExists.style.width=cursorIntervalWidth+"px";
	
    };
    
    
    
    var hasClass= function (element, cls) {
	return (' ' + element.className + ' ').indexOf(' ' + cls + ' ') > -1;
    };
    
  function eventFire(el, etype){
    if (el.fireEvent) {
      el.fireEvent('on' + etype);
    } else {
      var evObj = document.createEvent('Events');
      evObj.initEvent(etype, true, false);
      el.dispatchEvent(evObj);
    }
  }
  
    var prepareClick = function(element){	
	cursorStart();
	this.ubiready = setTimeout(function(that){
      
	    return function(){
		eventFire(that,"click");
		cursorEnd();
	    };
	}(this),400);
    };
    
  
    
    var loadMouseOver = function(element){

	element.addEventListener("mouseover",function(){
	    prepareClick.apply(this);
	});
	element.addEventListener("mouseout",function(){
	    clearTimeout(this.ubiready);
	    cursorEnd();
	});
    };
    
    var initEvent = function(elements){
	for (var i in elements){
	    if(!hasClass(elements[i],controls.loaded) && typeof elements[i] ==="object"){
		elements[i].className = elements[i].className + " " +controls.loaded;
		loadMouseOver(elements[i]);
	    }
	}
    };
    
    var load = function(){
	var elementCollection = document.getElementsByClassName(controls.click);
	initEvent(elementCollection);
    };
    
    return{
	load:load
    };
    
}();

(function($) {
 
          $.fn.mySlider = function() {
               $('#mycursor').show();
               $('#mycursor').css("background-image", "url('http://www.clker.com/cliparts/L/a/9/2/H/N/pointer-hand-mouse-hi.png')");
               $('body').mousemove(function(e) {
                 
              $('#mycursor').css('left', e.clientX - 20).css('top', e.clientY + 7);
                 
                 if({parameter:26} == 1)
                 {
                   $('h1').text(e.clientX);
                   
                 }
               
                 
               });
            
           };
       }(jQuery));

       $(document).ready(function() {
           $("body").mySlider();
         
         if({parameter:26} == 0)
                 {
                   $('h1').hide();
                   
                 }
         
       });
